// TXT2GTA2 version 2.1 (in C++)
// Feb 2010
// Cuban-Pete

#include <iostream>
#include <string>
#include <limits>
#include <sstream>

  
static char *colorList[] = {
	"0",				//normal
	"#b39564",			//light brown
	"white",			//white
	"#a2d0ff",			//bright blue
	"#95bfea",			//dark blue
	"#0099ff",			//Veteran
	"#ffff6e",			//VIP
	"#ffa34f",			//Administrator

    "0",				//Custom 
	"#eccbff",			//Elvis Mafia
	"#ff6312",			//Krishna
	"#61ff18",			//Loonies
	"#ffd26d",			//Mad Island Mafia
	"#007b46",			//Prison Mafia
	"#3852ff",			//Redneck
	"#dd2c2c",			//Russian Mafia
	"#ffb600",			//Scientists
	"#4941ff",			//Yakuza (version 1.1 had #4000ff)
	"#7a8c8f"			//Zaibatsu 
};

int carArray[256] = {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,13,6,11,0,0,0,0,5,0,0,0,0,5,11,5,0,12,7,12,12,15,12,12,14,12,12,5,0,0,0,0,0,0,12,12,12,12,12,12,12,12,9,12,14,12,19,12,12,12,14,12,12,11,13,16,22,15,15,15,0,0,0,0,0,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,12,0,0,0,0,0,0,0,0,0,0,0,0,0,12,0,12,0,19,0,0,0,0,0,0,12,12,0,0,0,0,0,0,0,0,0,0,12,0,0,0,0,0,0,0,5,0,0,0,0,0,0,0,12,12,12,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,12,12,12,0,9,12,11,0,12,0,0,0,9,0,12,13,12,12,0,0,0,0,0,0,12,12,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
}; //also fixed  and  stuff (example, 13 pixel wide = chr(32) = spacebar ... etc

using namespace std;

string IntToString(int intValue){ //fix ugly int to string
		string xTemp;		
		stringstream out;
		out << intValue;
		xTemp = out.str();
		return (xTemp);
};

int main(){
//cout << "this is max lenght of line   in dos box thingy... give one or two              \n";

system("cls");
cout << " ------------------------------------------------------------------------------\n";
cout << "                                  TXT2GTA2                         version 2.1 \n";                       
cout << " ------------------------------------------------------------------------------\n";
cout << endl;
cout << "                 0  -  Normal  font (i.e. chat)\n";
cout << endl;
cout << "                 1  -  Large   font (i.e. WASTED)\n";
cout << endl;
cout << "                 2  -  Menu    font\n";
cout << endl;
cout << "                 3  -  Street  signs\n";
cout << endl;
cout << "                 4  -  Car     license plate\n";
cout << endl;
cout << " ------------------------------------------------------------------------------\n";
cout << endl;

cout << "Enter font type number: ";
int inpFont;

while( ! ( cin >> inpFont ) ){
		label_enter_inpFont:
          cout << "Please enter a correct number: ";
          cin.clear();
          cin.ignore( numeric_limits<streamsize>::max(), '\n' );
			};

string folder;
if (inpFont == 0) folder = "alphabet/normal/";
else if (inpFont == 1) folder = "alphabet/large/";
else if (inpFont == 2) folder = "alphabet/menu/";
else if (inpFont == 3) folder = "alphabet/street/";
else if (inpFont == 4) folder = "alphabet/car/";
else if (inpFont > 4 || inpFont < 0) goto label_enter_inpFont;

string color;
int inpColor;

if (inpFont <= 2){ 
	system("cls");
	cout << " ------------------------------------------------------------------------------\n";
	cout << " ------------------------  Please pick a color  -------------------------------\n";
	cout << endl;
	cout << "              0   -  Normal (Enter)      5  -  Veteran (forum)\n";
	cout << "              1   -  Ligh Brown          6  -  VIP (forum)\n";
	cout << "              2   -  White (Grey)        7  -  Administrator (forum)\n";
	cout << "              3   -  Bright Blue\n";
	cout << "              4   -  Dark Blue           8  -  CUSTOM\n";
	cout << endl;
	cout << "              9   -  Elvis Mafia\n";
	cout << "              10  -  Krishna\n";
	cout << "              11  -  Loonies\n";
	cout << "              12  -  Mad Island Mafia\n";
	cout << "              13  -  Prison Mafia\n";
	cout << "              14  -  Redneck\n";
	cout << "              15  -  Russian Mafia\n";
	cout << "              16  -  Scientists\n";
	cout << "              17  -  Yakuza\n";
	cout << "              18  -  Zaibatsu\n";
	cout << endl;
	cout << " ------------------------------------------------------------------------------\n";
	cout << endl;
	cout << "Enter color number: ";

	while( ! ( cin >> inpColor ) ){
			label_enter_inpColor:
			  cout << "Please enter a correct number: ";
			  cin.clear();
			  cin.ignore( numeric_limits<streamsize>::max(), '\n' );
				};
		if (inpColor > 18 || inpColor < 0) goto label_enter_inpColor;
	
		for (int x=0; x<19; x++){
		if (inpColor == x)color = colorList[x]; //seems to work..  :P
		};

	 if (inpColor == 8){
			cout << "Use HTML (i.e. #ffc100) \nEnter the color code:";			
			cin.clear();
			cin.ignore(1000, '\n'); 
			cin >> color;	
			};
};

string inp; // this little guy is very important!
int autoAdjust = 0;

	if (inpFont == 4) {
	cout << "Maximum letters is around 20 (depends on width)! \nMore just don't fit on a license plate. \nEnter your text line: ";
	cin.clear();
	cin.ignore(1000, '\n'); 
	getline(cin, inp);
	cout << endl;
	
	
	cout << "Do you want background to auto adjust to text size? Enter y/n: ";
	cin.clear();
		retryYN:
			string autoString;
			getline(cin, autoString);

			//const char *autoString = autoStringTemp.c_str();
			//char *autoStringFin = strlwr(autoString);

			if (autoString == "y") autoAdjust = 1;
			else if (autoString == "n") autoAdjust = 0;
			else goto retryYN;
			};

	if (inpFont != 4) {
	cout << "Enter your text line: ";
	cin.clear();
	cin.ignore(1000, '\n');
	getline(cin, inp);
	};

int lenInp;
lenInp = inp.length();
cout << endl;
cout << "Working..." << endl;
cout << endl;

///////////////////////////// GETTING APPEND LIST AND BACKGROUND SIZE /////////////////////////////

string theAdding;
int lenBackground = 0; //set background lenght to 0

for (int x=0;lenInp > x; x++){
	//cout << inp[x] << endl;
	if (inpFont != 0){
		
		//inp[x] = char(toupper(inp[x])); //gives crash with , not working this...

		for (int y=97; y<124; y++){
		if (int(inp[x]) == y) inp[x] = char(y-32); //fix small text to large (don't know how to do  to  etc?)
		};
	};

	if (int(inp[x])<0){
		theAdding += folder;
		int temp = 256+inp[x];
		lenBackground += carArray[temp]; //background for car sign
		theAdding += IntToString(temp);
		theAdding += ".png ";	
		}
	else{
	theAdding += folder;
	theAdding += IntToString(int(inp[x]));
	lenBackground += carArray[int(inp[x])]; //background for car sign
	theAdding += ".png ";
	};
};

///////////////////////// APPENDING TEXT IMAGES TO ONE RESULT.PNG /////////////////////


string theMessage; //this goes to system(), or the .exe
theMessage = "imagemagick\\convert.exe ";
theMessage += theAdding;
theMessage +=" +append result.png";
const char *realMessage = theMessage.c_str(); // get const char * representation for stupid system() to work
system(realMessage);

////////////////////////////// COLOR WORK ////////////////////////////////////////


if (inpFont <= 2 && inpColor != 0){
	theMessage = "imagemagick\\convert.exe result.png -colorspace Gray -normalize +level-colors black,";
	theMessage += color;
	theMessage += " result.png";
	const char *realMessage = theMessage.c_str(); // get const char * representation for stupid system() to work
	system(realMessage);
	};

////////////////////////// BACKGROUND STREET ///////////////////////////////////////////

if (inpFont == 3) system("imagemagick\\composite.exe -gravity center result.png alphabet/street/background_street.png result.png"); 
// that was quick and easy....

////////////////////////// AUTO BACKGROUND CAR ///////////////////////////////////////////

if (inpFont == 4){
	if (autoAdjust){
			int midTest = 0;
			if (lenBackground > 202) midTest = 1;
			int cut;
				if (lenBackground <= 101){
					system("imagemagick\\convert.exe alphabet/car/background_left.png -crop -101+0 alphabet/left.png");

					cut = 101 - lenBackground;
					
					theMessage = "imagemagick\\convert.exe alphabet\\car\\background_right.png -crop +";
					theMessage += IntToString(cut);
					theMessage += "+0 alphabet/right.png";
					const char *realMessage = theMessage.c_str(); // get const char * representation for stupid system() to work
					system(realMessage);
				}
 				else if (lenBackground <= 202){
					system("imagemagick\\convert.exe alphabet/car/background_right.png alphabet/right.png");
					
					lenBackground -= 101;
					cut = 101 - lenBackground;
					
					theMessage = "imagemagick\\convert.exe alphabet/car/background_left.png -crop -";
					theMessage += IntToString(cut);
					theMessage += "+0 alphabet/left.png";
					const char *realMessage = theMessage.c_str(); // get const char * representation for stupid system() to work
					system(realMessage);
				}
				else {
					system("imagemagick\\convert.exe alphabet/car/background_right.png alphabet/right.png");
					system("imagemagick\\convert.exe alphabet/car/background_left.png alphabet/left.png");

					lenBackground -= 202;
					cut = 114 - lenBackground;

					if (cut >= 0){
						theMessage = "imagemagick\\convert.exe alphabet/car/background_middle.png -crop +";
						theMessage += IntToString(cut);
						theMessage += "+0 alphabet/mid.png";
						const char *realMessage = theMessage.c_str(); // get const char * representation for stupid system() to work
						system(realMessage);
						}
					else {
					cout << "Your text is too long for a license plate. Please retry with shorter text!" << endl; 
					_sleep(3000); //wait 3 sec to show the message than continue
					midTest = 2;
					};
				};
				// midTest is to prevent mid.png not found error in "gui"
				if (midTest == 1) system("imagemagick\\convert.exe alphabet/left.png alphabet/mid.png alphabet/right.png +append alphabet/background.png");
				else if (midTest == 2) midTest = 2; //just do nothing.... text too long
				else system("imagemagick\\convert.exe alphabet/left.png alphabet/right.png +append alphabet/background.png");

				//put background and text on each other (this is were only composite.exe needed for... freaking 5MB!!)
				if (midTest != 2) system("imagemagick\\composite.exe -gravity center result.png alphabet/background.png result.png"); 

			}
	////////////////////////// STATIC BACKGROUND CAR ///////////////////////////////////////////
			else system("imagemagick\\composite.exe -gravity center result.png alphabet/car/background_car.png result.png"); 


				};




//clean background junk up
system("alphabet\\remove_temp.bat");

cout << "done" << endl;
_sleep(900); // just not one second to see text 'done'. wooot! :D

//system("pause"); //temp?

return 0;
}
